package cz.zoubelu.config.web;

import cz.zoubelu.config.app.ApplicationConfig;
import cz.zoubelu.config.app.GraphConfig;
import cz.zoubelu.config.app.SchedulerConfig;
import cz.zoubelu.config.app.datasource.DataSourceProd;
import org.springframework.web.WebApplicationInitializer;
import org.springframework.web.context.ContextLoaderListener;
import org.springframework.web.context.support.AnnotationConfigWebApplicationContext;
import org.springframework.web.servlet.DispatcherServlet;

import javax.servlet.ServletContext;
import javax.servlet.ServletRegistration;

/**
 * Created by zoubas.
 */
public class WebInitializer implements WebApplicationInitializer {

    public void onStartup(ServletContext servletContext) {

        AnnotationConfigWebApplicationContext appContext = new AnnotationConfigWebApplicationContext();
        //application kontext
        appContext.register(ApplicationConfig.class, GraphConfig.class, DataSourceProd.class, SchedulerConfig.class);

        servletContext.addListener(new ContextLoaderListener(appContext));
        servletContext.setInitParameter("spring.profiles.active", "production");

        // Dispatcher Servlet kontext
        AnnotationConfigWebApplicationContext dispatcherServlet = new AnnotationConfigWebApplicationContext();
        dispatcherServlet.register(Dispatcher.class);

        // Register and map the dispatcher servlet
        ServletRegistration.Dynamic dispatcher = servletContext.addServlet("dispatcher", new DispatcherServlet(dispatcherServlet));
        dispatcher.setLoadOnStartup(1);
        dispatcher.addMapping("/");

    }

}