package cz.zoubelu.controller;

import it.sauronsoftware.cron4j.Scheduler;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * Created by zoubas.
 */
@RestController
@RequestMapping("/scheduler")
public class RestSchedulerController{

	@Autowired
	private Scheduler scheduler;


	private static final String OK ="Successfully ";
	private static final String FAIL = "Failed to procceed action. Reason: ";

	@RequestMapping("/start")
	public String startScheduler(Model model) {
		try {
			scheduler.start();
			return OK + " started.";
		} catch (Exception e) {
			return FAIL + e.getMessage();
		}
	}

	@RequestMapping("/stop")
	public String stopScheduler(Model model) {
		try {
			scheduler.stop();
			return OK + " stopped.";
		} catch (Exception e) {
			return FAIL + e.getMessage();
		}
	}

	@RequestMapping("status")
	public String getSchedulerStatus(){
		return scheduler.isStarted()? "Running":"Stopped";
	}


}
