package cz.zoubelu.repository;

import cz.zoubelu.domain.Application;
import cz.zoubelu.domain.ConsumeRelationship;
import cz.zoubelu.domain.Method;
import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.GraphRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;
import java.util.Map;

/**
 * Created by zoubas.
 */
public interface RelationshipRepository<T> extends GraphRepository<ConsumeRelationship> {

    @Query("MATCH (m:Method)<-[c:CONSUMES]-(a:Application) WHERE id(m)={mId} AND id(a)={appId} RETURN c")
    ConsumeRelationship findRelationship(@Param("appId") Application consumingApp, @Param("mId") Method consumedMethod);

    @Query("MATCH (n)-[r]->(m) RETURN n as application, m as method, r as rel")
    List<Map<String, T>> getGraph();

    @Query("START a=node(*) MATCH (a)-[r]->(m)  WHERE id(a)={appId} RETURN a as application,r as rel,m as method")
    List<Map<String, Object>> getApplicationRelationships(@Param("appId") Application application);
}
