package cz.zoubelu.service;

import cz.zoubelu.domain.Message;
import cz.zoubelu.model.ConversionError;
import cz.zoubelu.model.TimeRange;

import java.util.List;

/**
 * Created by zoubas.
 */
public interface DataConversion {

    /**
     * Converts relational data into nodes and relationships of graph integration, between the given time range.
     *
     * @param timeRange Time range the relational data are in.
     * @param tableName Name of the table.
     * @return errors collection.
     */
    List<ConversionError> convertData(String tableName, TimeRange timeRange);

    List<ConversionError> convertData(String tableName);

    /**
     * !! This method is for test purposes only. It's never used in production code. !!
     * @param messages
     * @return errors
     */
    List<ConversionError> convertData(List<Message> messages, TimeRange timeRange);

    void clearCache();


}
