package cz.zoubelu.service.impl;

import cz.zoubelu.model.ConversionError;
import org.apache.commons.mail.HtmlEmail;
import org.apache.log4j.Logger;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by zoubas.
 */
@Service
public class EmailSender {

    private final Logger log = Logger.getLogger(getClass());

    public void sendEmail(List<ConversionError> errors) {
        HtmlEmail email = new HtmlEmail();
        try {
            // z důvodu ochrany osobních údaje je konfigurace promazána.
            log.info("Sending email about errors.");
            /*
            email.setHostName("");
            email.setAuthentication("--------", "--------");
            email.addTo("");
            email.setFrom("", "Neo");
            email.setSubject("Neo - conversion results.");

            email.setHtmlMsg(createEmailBody(errors));
            email.setTextMsg("Your email client does not support HTML messages");
            email.send();
            */
        } catch (Exception e) {
            log.error("Failed to send email.", e);
        }
    }

    private String createEmailBody(List<ConversionError> errors) {
        String headline = "<h1>Following errors occur after conversion.</h1>";
        String body = "<ul>";

        for (ConversionError error : errors) {
            body += "<li>" + error.getMessage() + "</li>";
        }

        body += "</ul>";
        return "<html lang=\"cz\"></head><body>" + headline + "</p>" + body + "</body></html>";
    }
}
